Delete fulfillment attributes - Fabric

Delete fulfillment attributes

cURL

curl --request POST \
  --url https://api.fabric.inc/v3/carts/{cartId}/fulfillments/{fulfillmentId}/actions/delete-attributes \
  --header 'Authorization: Bearer <token>' \
  --header 'Content-Type: application/json' \
  --header 'x-fabric-tenant-id: <x-fabric-tenant-id>' \
  --data '
{
  "attributes": [
    "test"
  ]
}
'

Python

import requests

url = "https://api.fabric.inc/v3/carts/{cartId}/fulfillments/{fulfillmentId}/actions/delete-attributes"

payload = { "attributes": ["test"] }
headers = {
    "x-fabric-tenant-id": "<x-fabric-tenant-id>",
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.text)

JavaScript (Fetch)

const options = {
  method: 'POST',
  headers: {
    'x-fabric-tenant-id': '<x-fabric-tenant-id>',
    Authorization: 'Bearer <token>',
    'Content-Type': 'application/json'
  },
  body: JSON.stringify({attributes: ['test']})
};

fetch('https://api.fabric.inc/v3/carts/{cartId}/fulfillments/{fulfillmentId}/actions/delete-attributes', options)
  .then(res => res.json())
  .then(res => console.log(res))
  .catch(err => console.error(err));

PHP

$curl = curl_init();

curl_setopt_array($curl, [
  CURLOPT_URL => "https://api.fabric.inc/v3/carts/{cartId}/fulfillments/{fulfillmentId}/actions/delete-attributes",
  CURLOPT_RETURNTRANSFER => true,
  CURLOPT_ENCODING => "",
  CURLOPT_MAXREDIRS => 10,
  CURLOPT_TIMEOUT => 30,
  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
  CURLOPT_CUSTOMREQUEST => "POST",
  CURLOPT_POSTFIELDS => json_encode([
    'attributes' => [
        'test'
    ]
  ]),
  CURLOPT_HTTPHEADER => [
    "Authorization: Bearer <token>",
    "Content-Type: application/json",
    "x-fabric-tenant-id: <x-fabric-tenant-id>"
  ],
]);

$response = curl_exec($curl);
$err = curl_error($curl);

curl_close($curl);

if ($err) {
  echo "cURL Error #:" . $err;
} else {
  echo $response;
}

Go

package main

import (
    "fmt"
    "strings"
    "net/http"
    "io"
)

func main() {

url := "https://api.fabric.inc/v3/carts/{cartId}/fulfillments/{fulfillmentId}/actions/delete-attributes"

payload := strings.NewReader("{\n  \"attributes\": [\n    \"test\"\n  ]\n}")

req, _ := http.NewRequest("POST", url, payload)

req.Header.Add("x-fabric-tenant-id", "<x-fabric-tenant-id>")
    req.Header.Add("Authorization", "Bearer <token>")
    req.Header.Add("Content-Type", "application/json")

res, _ := http.DefaultClient.Do(req)

defer res.Body.Close()
    body, _ := io.ReadAll(res.Body)

fmt.Println(string(body))
}

Unirest (Java)

HttpResponse<String> response = Unirest.post("https://api.fabric.inc/v3/carts/{cartId}/fulfillments/{fulfillmentId}/actions/delete-attributes")
  .header("x-fabric-tenant-id", "<x-fabric-tenant-id>")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"attributes\": [\n    \"test\"\n  ]\n}")
  .asString();

Ruby

require 'uri'
require 'net/http'

url = URI("https://api.fabric.inc/v3/carts/{cartId}/fulfillments/{fulfillmentId}/actions/delete-attributes")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["x-fabric-tenant-id"] = '<x-fabric-tenant-id>'
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"attributes\": [\n    \"test\"\n  ]\n}"

response = http.request(request)
puts response.read_body

Response Codes

JSON Responses

Successful Response

{
  "id": "d6229cdb-0c5b-4885-b1b2-13b94d02488e",
  "type": "SHIP_TO",
  "refId": "398427903843",
  "attributes": {
    "source": "store"
  },
  "originAddress": "a8577d7f-0d4d-4b22-8e85-7b4a2e90dc93",
  "destinationAddress": "a8577d7f-0d4d-4b22-8e85-7b4a2e90dc93",
  "locationId": "CA",
  "pickupPerson": {
    "primary": {
      "name": {
        "first": "John",
        "middle": "S",
        "last": "Doe"
      },
      "email": "john@test.com",
      "phone": {
        "number": "123-456-7890",
        "type": "MOBILE"
      }
    },
    "secondary": [
      {
        "name": {
          "first": "John",
          "middle": "S",
          "last": "Doe"
        },
        "email": "john@test.com",
        "phone": {
          "number": "123-456-7890",
          "type": "MOBILE"
        }
      }
    ]
  },
  "price": {
    "amount": 12.99
  },
  "promotions": {
    "total": 15,
    "collection": [
      {
        "id": "bb44db95-6fbd-4eed-a1ed-4d99bc91250f",
        "amount": 15
      }
    ]
  },
  "fees": {
    "total": 5,
    "collection": [
      {
        "id": "a8577d7f-0d4d-4b22-8e85-7b4a2e90dc93",
        "name": "Eco Fee",
        "price": {
          "amount": 12.99
        },
        "taxable": true,
        "attributes": {
          "source": "eco"
        },
        "tax": {
          "total": 3,
          "collection": [
            {
              "amount": 3,
              "attributes": {
                "rate": "5.0",
                "type": "COUNTY"
              }
            }
          ]
        },
        "updatedAt": "2024-06-13T16:50:00.682Z",
        "createdAt": "2024-06-13T16:50:00.682Z",
        "taxDetails": {
          "destinationAddress": "c86f777b-1885-4ddf-961d-542ba80a69b8",
          "originAddress": "c86f777b-1885-4ddf-961d-542ba80a69b8"
        }
      }
    ]
  },
  "adjustments": {
    "total": 2,
    "collection": [
      {
        "id": "a8577d7f-0d4d-4b22-8e85-7b4a2e90dc93",
        "price": {
          "amount": 12.99
        },
        "reason": "Price adjustment from customer representative.",
        "attributes": {
          "source": "CSR"
        },
        "updatedAt": "2024-06-13T16:50:00.682Z",
        "createdAt": "2024-06-13T16:50:00.682Z"
      }
    ]
  },
  "tax": {
    "total": 3,
    "collection": [
      {
        "amount": 3,
        "attributes": {
          "rate": "5.0",
          "type": "COUNTY"
        }
      }
    ]
  }
}

Error Responses

{
  "type": "BAD_REQUEST",
  "message": "x-fabric-tenant-id is required"
}
{
  "type": "CART_NOT_FOUND",
  "message": "Cart not found"
}